Attribute VB_Name = "Module2"
Option Explicit

Public Declare Function ContourCalculateIsolines Lib "Contour" (ByVal i As Long, d As Double) As Long
Public Declare Function ContourSetGrid Lib "Contour" (ByVal nX As Long, ByVal nY As Long, aX As Double, aY As Double, aV As Double) As Long
Public Declare Function ContourSetGridEx Lib "Contour" (ByVal nX As Long, ByVal nY As Long, aX As Double, aY As Double, aV As Double, aT As Long) As Long
Public Declare Function ContourDelete Lib "Contour" () As Long
Public Declare Function ContourCreate Lib "Contour" () As Long
Public Declare Function ContourIsolinesCount Lib "Contour" () As Long
Public Declare Function ContourLinesCount Lib "Contour" (ByVal nL As Long) As Long
Public Declare Function ContourPointsCount Lib "Contour" (ByVal nL As Long, ByVal nL As Long) As Long
Public Declare Function ContourGetPoint Lib "Contour" (ByVal nL As Long, ByVal nL As Long, ByVal nL As Long, d As Double, a As Double) As Long
Public Declare Function ContourGridGetMinMax Lib "Contour" (ByRef dMin As Double, ByRef dMax As Double) As Long
Public Declare Function ContourGetIsolinePoints Lib "Contour" (ByVal nIsoloine As Long, ByVal nLine As Long, ByRef dCoordX As Double, ByRef dCoordY As Double) As Long

Public Declare Function DemoContourDelete Lib "DemoContour" () As Long
Public Declare Function DemoContourCreate Lib "DemoContour" () As Long

Public Declare Function DemoContourCanvasSetHDC Lib "DemoContour" (ByVal hDC As Long) As Long
Public Declare Function DemoContourCanvasSetLimits Lib "DemoContour" (ByVal dXMin As Double, ByVal dYMin As Double, ByVal dXMax As Double, ByVal dYMax As Double) As Long
Public Declare Function DemoContourCanvasSetLabelValue Lib "DemoContour" (ByVal dValue As Double) As Long
Public Declare Function DemoContourCanvasDrawContour Lib "DemoContour" (ByVal nCount As Long, ByRef dX As Double, ByRef dY As Double) As Long
Public Declare Function DemoContourCanvasSetSize Lib "DemoContour" (ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function DemoContourCanvasSetFontHeight Lib "DemoContour" (ByVal nHeight As Long) As Long
Public Declare Function DemoContourCanvasSetFontFaceName Lib "DemoContour" (ByVal sName As String) As Long
Public Declare Function DemoContourCanvasSetXYRate Lib "DemoContour" (ByVal nXYRate As Long) As Long
Public Declare Function DemoContourCanvasCoordinateX Lib "DemoContour" (ByVal lPixelX As Long) As Double
Public Declare Function DemoContourCanvasCoordinateY Lib "DemoContour" (ByVal lPixelY As Long) As Double
Public Declare Function DemoContourCanvasPixelX Lib "DemoContour" (ByVal dX As Double) As Long
Public Declare Function DemoContourCanvasPixelY Lib "DemoContour" (ByVal dY As Double) As Long
Public Declare Function DemoContourLabelSetTransparent Lib "DemoContour" (ByVal nCode As Long) As Long

Public Declare Function DemoContourAxisAdd Lib "DemoContour" (ByVal sAxeType As String) As Long
Public Declare Function DemoContourAxisDraw Lib "DemoContour" () As Long
Public Declare Function DemoContourAxisSetTitle Lib "DemoContour" (ByVal nAxe As Long, ByVal sAxeType As String) As Long
Public Declare Function DemoContourAxisSetFontFaceName Lib "DemoContour" (ByVal nAxe As Long, ByVal sFontName As String) As Long
Public Declare Function DemoContourAxisSetFontHeight Lib "DemoContour" (ByVal nAxe As Long, ByVal nFontHeight As Long) As Long
Public Declare Function DemoContourAxisSetLongTick Lib "DemoContour" (ByVal nAxe As Long, ByVal nYes As Long) As Long
Public Declare Function DemoContourAxisSetAutoTicks Lib "DemoContour" (ByVal nAxe As Long, ByVal nYes As Long) As Long
Public Declare Function DemoContourAxisSetTicks Lib "DemoContour" (ByVal nAxe As Long, ByVal dFirst As Double, ByVal dStep As Double, ByVal nCount As Long) As Long
Public Declare Function DemoContourAxisSetAutoDecimalPlace Lib "DemoContour" (ByVal nAxe As Long, ByVal nYes As Long) As Long
Public Declare Function DemoContourAxisSetDecimalPlace Lib "DemoContour" (ByVal nAxe As Long, ByVal nPlace As Long) As Long
Public Declare Function DemoContourAxisCalculate Lib "DemoContour" () As Long
Public Declare Function DemoContourAxisSimpleDraw Lib "DemoContour" () As Long

Dim CONTOUR_RC_OK As Long
Dim CONTOUR_RC_ERROR As Long
Dim CONTOUR_RC_NO_MEMORY As Long
Dim CONTOUR_RC_EXIST As Long
Dim CONTOUR_RC_NO_EXIST As Long

Dim GlnPoints As Long
Dim GldLineCoordX(0 To 10000) As Double
Dim GldLineCoordY(0 To 10000) As Double

' The grid coordinates
Public GldColumnCoord(0 To 1500) As Double
Public GldRowCoord(0 To 1500) As Double

' Count of rows and colums of grid
Public GlnRowCount As Long
Public GlnColumnCount As Long

' Values of grid
Public GlardV(0 To 1000000) As Double

' Values of contours
Public GdaContourValues(0 To 100) As Double

Sub Init()
    Dim nRC As Long

Dim CONTOUR_RC_OK As Long
Dim CONTOUR_RC_ERROR As Long
Dim CONTOUR_RC_NO_MEMORY As Long
Dim CONTOUR_RC_EXIST As Long
Dim CONTOUR_RC_NO_EXIST As Long
        
    ' Return codes for CONTOUR
    CONTOUR_RC_OK = 0
    CONTOUR_RC_ERROR = -1
    CONTOUR_RC_NO_MEMORY = -2
    CONTOUR_RC_EXIST = 1
    CONTOUR_RC_NO_EXIST = 2
    
    On Error GoTo MetkaErrorContourCreate
    ' Create Contour object
    nRC = DemoContourCreate()
    nRC = ContourCreate()
    If nRC <> CONTOUR_RC_OK Then
        If nRC = CONTOUR_RC_EXIST Then
            Debug.Print "Object Contour exist"
        End If
        If nRC = CONTOUR_RC_ERROR Then
            MsgBox ("Can't create object Contour")
            Exit Sub
        End If
    End If
    
    Exit Sub
    
    
MetkaErrorContourCreate:
    MsgBox ("Function ContourCreate is missing")
    Exit Sub
    
End Sub

Sub FClose()
    Dim nRC As Long
    
    nRC = DemoContourDelete()
    nRC = ContourDelete()
    
    Exit Sub

End Sub


Sub CreateContours()
    Dim dMin As Double
    Dim dMax As Double
    Dim nRC As Long
    Dim d As Double
    Dim nCount As Long
    Dim nLines As Long
    Dim nI As Long
    Dim nJ As Long
    Dim nK As Long
    Dim dCoeffX As Double
    Dim dCoeffY As Double
    Dim dX1 As Double
    Dim dY1 As Double
    Dim dX2 As Double
    Dim dY2 As Double
    Dim sFile As String
    Dim longWidth As Long
    Dim longHeight As Long
    Dim sFont As String
    Dim lPixelX As Long
    Dim lPixelY As Long
    Dim dWidth As Double
    Dim dHeight As Double
    
    Dim dXMin As Double
    Dim dXMax As Double
    Dim dYMin As Double
    Dim dYMax As Double
    
    Dim dXStep As Double
    Dim dYStep As Double
        
    ' Return codes for CONTOUR
    CONTOUR_RC_OK = 0
    CONTOUR_RC_ERROR = -1
    CONTOUR_RC_NO_MEMORY = -2
    CONTOUR_RC_EXIST = 1
    CONTOUR_RC_NO_EXIST = 2
    
    dWidth = Demo.Picture1.Width
    dHeight = Demo.Picture1.Height
 
    
    On Error GoTo MetkaNoFile
    sFile = "Matrix.txt"
    Open sFile For Input As #1      ' Open file
        
    Input #1, GlnRowCount, GlnColumnCount
    
    For nJ = 0 To GlnRowCount - 1
        For nI = 0 To GlnColumnCount - 1
            Input #1, GlardV(nJ * GlnColumnCount + nI)
        Next nI
    Next nJ
    
    Close
    
    If GlnRowCount > 50 Or GlnColumnCount > 50 Then
         MsgBox ("Sorry. It is demo. Grid size no more 50x50")
         Exit Sub
    End If
    
'   Size of demo map is (1,1)
    dXMin = 0
    dXMax = 1
    dYMin = 0
    dYMax = 1
    
'   Calculate the steps of grid
    dXStep = (dXMax - dXMin) / (GlnColumnCount - 1)
    dYStep = (dYMax - dYMin) / (GlnRowCount - 1)
    
'   Calculate the coordinates of grid
    GldColumnCoord(0) = dXMin
    For nJ = 1 To GlnColumnCount - 1
        GldColumnCoord(nJ) = GldColumnCoord(nJ - 1) + dXStep
    Next nJ
    
    GldRowCoord(0) = dYMin
    For nJ = 1 To GlnRowCount - 1
        GldRowCoord(nJ) = GldRowCoord(nJ - 1) + dYStep
    Next nJ
    
    dCoeffY = dHeight / (GldRowCoord(GlnRowCount - 1) - GldRowCoord(0))
    dCoeffX = dWidth / (GldColumnCoord(GlnColumnCount - 1) - GldColumnCoord(0))
    
    
    ' Create the grid object
    On Error GoTo MetkaErrorContourCreateGrid
    nRC = ContourSetGrid(GlnColumnCount, GlnRowCount, GldColumnCoord(0), GldRowCoord(0), GlardV(0))
    
    If (nRC = CONTOUR_RC_ERROR Or nRC = CONTOUR_RC_NO_MEMORY) Then
         MsgBox ("Object Contour can't create a grid")
         Exit Sub
    End If
    If (nRC > CONTOUR_RC_ERROR) Then
        Debug.Print "Count of grid points is " & Trim(Str(nRC))
    End If
    
    ' Get the min and max value of grid
    nRC = ContourGridGetMinMax(dMin, dMax)
    
    ' Set contour values array ( 9 values )
    d = dMax - dMin
    GdaContourValues(0) = dMin + d * 0.1
    GdaContourValues(1) = dMin + d * 0.2
    GdaContourValues(2) = dMin + d * 0.3
    GdaContourValues(3) = dMin + d * 0.4
    GdaContourValues(4) = dMin + d * 0.5
    GdaContourValues(5) = dMin + d * 0.6
    GdaContourValues(6) = dMin + d * 0.7
    GdaContourValues(7) = dMin + d * 0.8
    GdaContourValues(8) = dMin + d * 0.9
    nCount = 9
    ' Calculate 9 contours
    nRC = ContourCalculateIsolines(nCount, GdaContourValues(0))
    
    Exit Sub

MetkaNoFile:
    MsgBox ("File " & sFile & " is missing")
    Close
    Exit Sub
    
MetkaErrorContourCreateGrid:
    MsgBox ("Function ContourCreate is missing")
    Exit Sub
End Sub



Sub DrawContours()
    Dim dWidth As Double
    Dim dHeight As Double
    Dim longWidth As Long
    Dim longHeight As Long
    Dim sFont As String
    Dim lLeft As Long
    Dim lRight As Long
    Dim lTop As Long
    Dim lBottom As Long
    Dim lPixelX As Long
    Dim lPixelY As Long
    
    Dim dXMin As Double
    Dim dXMax As Double
    Dim dYMin As Double
    Dim dYMax As Double
    
    Dim nCount As Long
    Dim nRC As Long
    Dim nLines As Long
    Dim nI As Long
    Dim nJ As Long
    
    If GlnRowCount > 50 Or GlnColumnCount > 50 Then
         Exit Sub
    End If
    
    Demo.Picture1.Cls
    dWidth = Demo.Picture1.Width
    dHeight = Demo.Picture1.Height
    
    ' Add the axis. The return code is axe index or -1 if fault
    lBottom = DemoContourAxisAdd("bottom")
    lTop = DemoContourAxisAdd("top")
    lLeft = DemoContourAxisAdd("left")
    lRight = DemoContourAxisAdd("right")
    
    ' Change font height. The default is 18
    Call DemoContourAxisSetFontHeight(lBottom, 10)
    Call DemoContourAxisSetFontHeight(lTop, 10)
    Call DemoContourAxisSetFontHeight(lLeft, 10)
    Call DemoContourAxisSetFontHeight(lRight, 10)
    
    ' Set the legends
    Call DemoContourAxisSetTitle(lBottom, "X, m")
    Call DemoContourAxisSetTitle(lLeft, "Y, m")
    Call DemoContourAxisSetTitle(lTop, "Top")
    
    
    ' Get count of groups of contour
    nCount = ContourIsolinesCount()
    
    ' Set HDC for canvas
    nRC = DemoContourCanvasSetHDC(Demo.Picture1.hDC)
    
    ' Set off the XY rate (1 - on, 0 - off)
    Call DemoContourCanvasSetXYRate(0)
    
    ' Set canvas size in pixels
    longWidth = Demo.Picture1.ScaleX(dWidth, vbTwips, vbPixels)
    longHeight = Demo.Picture1.ScaleY(dHeight, vbTwips, vbPixels)
    nRC = DemoContourCanvasSetSize(longWidth, longHeight)
    
    ' Set view rectangle for canvas
    ' The function set pixel-coordinate system
    nRC = DemoContourCanvasSetLimits(GldColumnCoord(0), GldRowCoord(0), _
        GldColumnCoord(GlnColumnCount - 1), GldRowCoord(GlnRowCount - 1))
            
    sFont = "Times New Roman" ' Use TRUE TYPE fonts ONLY
    ' Default font is Arial
    nRC = DemoContourCanvasSetFontFaceName(sFont)
    ' Default font height is 20
    nRC = DemoContourCanvasSetFontHeight(15)
    
    Call DemoContourAxisDraw
    
    For nI = 0 To nCount - 1
        ' Set label value
        nRC = DemoContourCanvasSetLabelValue(GdaContourValues(nI))
        
        ' Get count of lines in nI group (for value aContourValues(nI))
        nLines = ContourLinesCount(nI)
        For nJ = 0 To nLines - 1
            ' Get count of vertexs of nJ line for nI group
            GlnPoints = ContourPointsCount(nI, nJ)
            nRC = ContourGetIsolinePoints(nI, nJ, GldLineCoordX(0), GldLineCoordY(0))
            ' Draw contour line
            Call DemoContourCanvasDrawContour(GlnPoints, GldLineCoordX(0), GldLineCoordY(0))
        Next nJ
    Next nI
    Exit Sub
End Sub



